package com.virjar.majora.adr;

import com.virjar.majora.client.sdk.log.MajoraLogger;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

public class Shell {

    public static void executeCmd(String cmd) {
        try {
            Process process = Runtime.getRuntime().exec("su");
            OutputStream outputStream = process.getOutputStream();
            outputStream.write(cmd.getBytes());
            outputStream.write("\n".getBytes());

            StringBuffer out = new StringBuffer();
            StringBuffer error = new StringBuffer();

            autoFillOutput(process.getInputStream(), out);
            autoFillOutput(process.getErrorStream(), error);
            process.waitFor();
        } catch (Throwable throwable) {
            MajoraLogger.getLogger().info("executeCmd error", throwable);
        }
    }

    private static void autoFillOutput(final InputStream inputStream, final StringBuffer stringBuffer) {
        new Thread() {
            @Override
            public void run() {
                try {
                    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
                    String line;
                    while ((line = bufferedReader.readLine()) != null) {
                        stringBuffer.append(line).append("\n");
                    }
                    bufferedReader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                } finally {
                    try {
                        inputStream.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        }.start();
    }
}
